## ceph 13.2.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

project(ceph CXX C ASM)
set(VERSION 13.2.7)

if(POLICY CMP0028)
  cmake_policy(SET CMP0028 NEW)
endif()
if(POLICY CMP0046)
  cmake_policy(SET CMP0046 NEW)
endif()
if(POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif()
if(POLICY CMP0056)
  cmake_policy(SET CMP0056 NEW)
endif()
if(POLICY CMP0065)
  cmake_policy(SET CMP0065 NEW)
endif()
if(POLICY CMP0051)
  cmake_policy(SET CMP0051 NEW)
endif()
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
  set(LINUX ON)
  FIND_PACKAGE(Threads)
elseif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
  set(FREEBSD ON)
  FIND_PACKAGE(Threads)
endif(CMAKE_SYSTEM_NAME MATCHES "Linux")

option(WITH_CCACHE "Build with ccache.")
if(WITH_CCACHE)
  find_program(CCACHE_FOUND ccache)
  if(CCACHE_FOUND)
    message(STATUS "Building with ccache: ${CCACHE_FOUND}, CCACHE_DIR=$ENV{CCACHE_DIR}")
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    # ccache does not accelerate link (ld), but let it handle it. by passing it
    # along with cc to python's distutils, we are able to workaround
    # https://bugs.python.org/issue8027.
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
  else(CCACHE_FOUND)
    message(FATAL_ERROR "Can't find ccache. Is it installed?")
  endif(CCACHE_FOUND)
endif(WITH_CCACHE)

option(WITH_MANPAGE "Build man pages." ON)
if(WITH_MANPAGE)
  find_program(SPHINX_BUILD
    sphinx-build)
  if(NOT SPHINX_BUILD)
    message(FATAL_ERROR "Can't find sphinx-build.")
  endif(NOT SPHINX_BUILD)
endif(WITH_MANPAGE)

include_directories(
  ${PROJECT_BINARY_DIR}/src/include
  ${PROJECT_SOURCE_DIR}/src)

if(OFED_PREFIX)
  include_directories(SYSTEM ${OFED_PREFIX}/include)
  link_directories(${OFED_PREFIX}/lib)
endif()

if(FREEBSD)
  include_directories(SYSTEM /usr/local/include)
  link_directories(/usr/local/lib)
  list(APPEND CMAKE_REQUIRED_INCLUDES /usr/local/include)
endif(FREEBSD)

#Check Includes
include(CheckIncludeFiles)
include(CheckIncludeFileCXX)
include(CheckFunctionExists)

#put all the libs and binaries in one place
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)


CHECK_FUNCTION_EXISTS(fallocate CEPH_HAVE_FALLOCATE)
CHECK_FUNCTION_EXISTS(posix_fadvise HAVE_POSIX_FADVISE)
CHECK_FUNCTION_EXISTS(posix_fallocate HAVE_POSIX_FALLOCATE)
CHECK_FUNCTION_EXISTS(syncfs HAVE_SYS_SYNCFS)
CHECK_FUNCTION_EXISTS(sync_file_range HAVE_SYNC_FILE_RANGE)
CHECK_FUNCTION_EXISTS(pwritev HAVE_PWRITEV)
CHECK_FUNCTION_EXISTS(splice CEPH_HAVE_SPLICE)
CHECK_FUNCTION_EXISTS(getgrouplist HAVE_GETGROUPLIST)
if(NOT APPLE)
  CHECK_FUNCTION_EXISTS(fdatasync HAVE_FDATASYNC)
endif()
CHECK_FUNCTION_EXISTS(strerror_r HAVE_Strerror_R)
CHECK_FUNCTION_EXISTS(name_to_handle_at HAVE_NAME_TO_HANDLE_AT)
CHECK_FUNCTION_EXISTS(pipe2 HAVE_PIPE2)
CHECK_FUNCTION_EXISTS(accept4 HAVE_ACCEPT4)

set(CMAKE_REQUIRED_LIBRARIES pthread)
CHECK_FUNCTION_EXISTS(pthread_spin_init HAVE_PTHREAD_SPINLOCK)
CHECK_FUNCTION_EXISTS(pthread_set_name_np HAVE_PTHREAD_SET_NAME_NP)
CHECK_FUNCTION_EXISTS(pthread_setname_np HAVE_PTHREAD_SETNAME_NP)
CHECK_FUNCTION_EXISTS(pthread_getname_np HAVE_PTHREAD_GETNAME_NP)
CHECK_FUNCTION_EXISTS(pthread_rwlockattr_setkind_np HAVE_PTHREAD_RWLOCKATTR_SETKIND_NP)
CHECK_FUNCTION_EXISTS(eventfd HAVE_EVENTFD)
CHECK_FUNCTION_EXISTS(getprogname HAVE_GETPROGNAME)

CHECK_INCLUDE_FILES("linux/types.h" HAVE_LINUX_TYPES_H)
CHECK_INCLUDE_FILES("linux/version.h" HAVE_LINUX_VERSION_H)
CHECK_INCLUDE_FILES("arpa/nameser_compat.h" HAVE_ARPA_NAMESER_COMPAT_H)
CHECK_INCLUDE_FILES("sys/mount.h" HAVE_SYS_MOUNT_H)
CHECK_INCLUDE_FILES("sys/param.h" HAVE_SYS_PARAM_H)
CHECK_INCLUDE_FILES("sys/types.h" HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES("sys/vfs.h" HAVE_SYS_VFS_H)
CHECK_INCLUDE_FILES("sys/prctl.h" HAVE_SYS_PRCTL_H)
CHECK_INCLUDE_FILES("execinfo.h" HAVE_EXECINFO_H)
if(LINUX)
  CHECK_INCLUDE_FILES("sched.h" HAVE_SCHED)
endif(LINUX)
CHECK_INCLUDE_FILES("valgrind/helgrind.h" HAVE_VALGRIND_HELGRIND_H)

include(CheckTypeSize)
set(CMAKE_EXTRA_INCLUDE_FILES "linux/types.h")
CHECK_TYPE_SIZE(__be16 __BE16) 
CHECK_TYPE_SIZE(__be32 __BE32) 
CHECK_TYPE_SIZE(__be64 __BE64) 
CHECK_TYPE_SIZE(__le16 __LE16) 
CHECK_TYPE_SIZE(__le32 __LE32) 
CHECK_TYPE_SIZE(__le64 __LE64) 
CHECK_TYPE_SIZE(__u8 __U8) 
CHECK_TYPE_SIZE(__u16 __U16) 
CHECK_TYPE_SIZE(__u32 __U32) 
CHECK_TYPE_SIZE(__u64 __U64) 
CHECK_TYPE_SIZE(__s8 __S8) 
CHECK_TYPE_SIZE(__s16 __S16) 
CHECK_TYPE_SIZE(__s32 __S32) 
CHECK_TYPE_SIZE(__s64 __S64) 
unset(CMAKE_EXTRA_INCLUDE_FILES)

include(CheckSymbolExists)
CHECK_SYMBOL_EXISTS(res_nquery "resolv.h" HAVE_RES_NQUERY)
CHECK_SYMBOL_EXISTS(F_SETPIPE_SZ "linux/fcntl.h" CEPH_HAVE_SETPIPE_SZ)
CHECK_SYMBOL_EXISTS(__func__ "" HAVE_FUNC)
CHECK_SYMBOL_EXISTS(__PRETTY_FUNCTION__ "" HAVE_PRETTY_FUNC)
CHECK_SYMBOL_EXISTS(getentropy "unistd.h" HAVE_GETENTROPY)

include(CheckCXXSourceCompiles)
CHECK_CXX_SOURCE_COMPILES("
  #include <string.h>
  int main() { char x = *strerror_r(0, &x, sizeof(x)); return 0; }
  " STRERROR_R_CHAR_P)

include(CheckStructHasMember)
CHECK_STRUCT_HAS_MEMBER("struct stat" st_mtim.tv_nsec sys/stat.h
  HAVE_STAT_ST_MTIM_TV_NSEC LANGUAGE C)
CHECK_STRUCT_HAS_MEMBER("struct stat" st_mtimespec.tv_nsec sys/stat.h
  HAVE_STAT_ST_MTIMESPEC_TV_NSEC LANGUAGE C)

set(CEPH_MAN_DIR "share/man" CACHE STRING "Install location for man pages (relative to prefix).")

option(ENABLE_SHARED "build shared libraries" ON)
if(ENABLE_SHARED)
  set(CEPH_SHARED SHARED)
else(ENABLE_SHARED)
  set(CEPH_SHARED STATIC)
endif(ENABLE_SHARED)
set(CMAKE_POSITION_INDEPENDENT_CODE ${ENABLE_SHARED})

option(WITH_STATIC_LIBSTDCXX "Link against libstdc++ statically" OFF)
if(WITH_STATIC_LIBSTDCXX)
  if(CMAKE_COMPILER_IS_GNUCXX)
    set(static_linker_flags "-static-libstdc++ -static-libgcc")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${static_linker_flags}")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${static_linker_flags}")
    unset(static_linker_flags)
  else()
    message(FATAL_ERROR "Please use GCC to enable WITH_STATIC_LIBSTDCXX")
  endif()
endif()

option(WITH_RDMA "Enable RDMA in async messenger" ON)
if(WITH_RDMA)
  find_package(rdma REQUIRED)
  set(HAVE_RDMA ${RDMA_FOUND})
endif(WITH_RDMA)

find_package(Backtrace)

if(LINUX)
  find_package(udev REQUIRED)
  set(HAVE_UDEV ${UDEV_FOUND})
  find_package(blkid REQUIRED)
  set(HAVE_BLKID ${BLKID_FOUND})
else()
  set(HAVE_UDEV OFF)
  message(STATUS "Not using udev")
  set(HAVE_BLKID OFF)
  message(STATUS "Not using BLKID")
endif(LINUX)

option(WITH_OPENLDAP "OPENLDAP is here" ON)
if(WITH_OPENLDAP)
  find_package(OpenLdap REQUIRED)
  set(HAVE_OPENLDAP ${OPENLDAP_FOUND})
endif()

option(WITH_FUSE "Fuse is here" ON)
if(WITH_FUSE)
  find_package(fuse)
  set(HAVE_LIBFUSE ${FUSE_FOUND})
endif()

option(WITH_XFS "XFS is here" ON)
if(WITH_XFS)
  find_package(xfs)
  set(HAVE_LIBXFS ${XFS_FOUND})
endif()

option(WITH_ZFS "enable LibZFS if found" OFF)
if(WITH_ZFS)
  find_package(zfs)
  set(HAVE_LIBZFS ${ZFS_FOUND})
endif()

option(WITH_BLUESTORE "Bluestore OSD backend" ON)
if(WITH_BLUESTORE)
  find_package(aio)
  set(HAVE_LIBAIO ${AIO_FOUND})
endif()

option(WITH_SPDK "Enable SPDK" OFF)
if(WITH_SPDK)
  if(NOT WITH_BLUESTORE)
    message(SEND_ERROR "Please enable WITH_BLUESTORE for using SPDK")
  endif()
  include(BuildSPDK)
  build_spdk()
  set(HAVE_SPDK TRUE)
endif(WITH_SPDK)

option(WITH_PMEM "Enable PMEM" OFF)
if(WITH_PMEM)
  set(HAVE_PMEM ON)
  if(NOT WITH_BLUESTORE)
    message(SEND_ERROR "Please enable WITH_BLUESTORE for using PMEM")
  endif()
endif()

if(WITH_BLUESTORE)
  if(NOT AIO_FOUND AND NOT WITH_SPDK AND NOT WITH_PMEM)
    message(SEND_ERROR "WITH_BLUESTORE is ON, "
      "but none of the bluestore backends is enabled. "
      "Please install libaio, or enable WITH_SPDK or WITH_PMEM (experimental)")
  endif()
endif()

option(WITH_BLUEFS "libbluefs library" OFF)

# needs mds and? XXX
option(WITH_LIBCEPHFS "libcephfs client library" ON)

# key-value store
option(WITH_KVS "Key value store is here" ON)

# remote block storage
option(WITH_RBD "Remote block storage is here" ON)

# KERNEL remote block storage
option(WITH_KRBD "Kernel Remote block storage is here" ON)

if(WITH_KRBD AND WITHOUT_RBD)
  message(FATAL_ERROR "Cannot have WITH_KRBD with WITH_RBD.")
endif()

option(WITH_LEVELDB "LevelDB is here" ON)
if(WITH_LEVELDB)
  if(LEVELDB_PREFIX)
    include_directories(SYSTEM ${LEVELDB_PREFIX}/include)
    link_directories(${LEVELDB_PREFIX}/lib)
  endif()
  find_package(leveldb REQUIRED)
  find_file(HAVE_LEVELDB_FILTER_POLICY leveldb/filter_policy.h PATHS ${LEVELDB_INCLUDE_DIR})
endif(WITH_LEVELDB)

find_package(snappy REQUIRED)

option(WITH_BROTLI "Brotli compression support" OFF)
if(WITH_BROTLI)
  set(HAVE_BROTLI TRUE)
endif()

option(WITH_LZ4 "LZ4 compression support" ON)
if(WITH_LZ4)
  find_package(LZ4 1.7 REQUIRED)
  set(HAVE_LZ4 ${LZ4_FOUND})
endif(WITH_LZ4)

#if allocator is set on command line make sure it matches below strings
if(ALLOCATOR)
  if(${ALLOCATOR} MATCHES "tcmalloc(_minimal)?")
    find_package(gperftools REQUIRED)
    set(HAVE_LIBTCMALLOC ON)
  elseif(${ALLOCATOR} STREQUAL "jemalloc")
    find_package(JeMalloc REQUIRED)
    set(HAVE_LIBJEMALLOC ${JEMALLOC_FOUND})
    set(HAVE_JEMALLOC 1)
  endif()
else(ALLOCATOR)
  find_package(gperftools)
  set(HAVE_LIBTCMALLOC ${GPERFTOOLS_FOUND})
  if(NOT GPERFTOOLS_FOUND)
    find_package(JeMalloc)
    set(HAVE_LIBJEMALLOC ${JEMALLOC_FOUND})
  endif(NOT GPERFTOOLS_FOUND)
  if(GPERFTOOLS_FOUND)
    set(ALLOCATOR tcmalloc)
  elseif(JEMALLOC_FOUND)
    set(ALLOCATOR jemalloc)
  else()
    if(NOT FREEBSD)
      # FreeBSD already has jemalloc as its default allocator
      message(WARNING "tcmalloc and jemalloc not found, falling back to libc")
    endif()
    set(ALLOCATOR "libc")
  endif(GPERFTOOLS_FOUND)
endif(ALLOCATOR)

if(HAVE_LIBTCMALLOC AND WITH_STATIC_LIBSTDCXX)
  set(EXE_LINKER_USE_PIE FALSE)
else()
  set(EXE_LINKER_USE_PIE ${ENABLE_SHARED})
endif()

if(WITH_LIBCEPHFS OR WITH_KRBD)
  find_package(keyutils REQUIRED)
endif()

find_package(CURL REQUIRED)
set(CMAKE_REQUIRED_INCLUDES ${CURL_INCLUDE_DIRS})
set(CMAKE_REQUIRED_LIBRARIES ${CURL_LIBRARIES})
CHECK_SYMBOL_EXISTS(curl_multi_wait curl/curl.h HAVE_CURL_MULTI_WAIT)

find_package(NSS REQUIRED)
find_package(NSPR REQUIRED)
find_package(OpenSSL REQUIRED)
# TODO: use NSS only for validation of the OpenSSL-based implementations
set(USE_NSS 1)
set(USE_OPENSSL 1)
set(CRYPTO_LIBS ${NSS_LIBRARIES} ${NSPR_LIBRARIES} ${OPENSSL_LIBRARIES})
set(SSL_LIBRARIES ${NSS_LIBRARIES} ${OPENSSL_LIBRARIES})

option(WITH_XIO "Enable XIO messaging" OFF)
if(WITH_XIO)
  find_package(xio REQUIRED)
  set(HAVE_XIO ${XIO_FOUND})
endif()

option(WITH_DPDK "Enable DPDK messaging" OFF)
if(WITH_DPDK)
  find_package(dpdk)
  set(HAVE_DPDK ${DPDK_FOUND})
  if(NOT TARGET dpdk-ext)
    find_package(dpdk)
    if(NOT DPDK_FOUND)
      include(BuildDPDK)
      build_dpdk()
    endif()
  endif()
endif()

option(WITH_BLKIN "Use blkin to emit LTTng tracepoints for Zipkin" OFF)
if(WITH_BLKIN)
  set(BLKIN_LIBRARIES blkin ${LTTNGUST_LIBRARIES} lttng-ust-fork)
  include_directories(SYSTEM src/blkin/blkin-lib)
endif(WITH_BLKIN)

option(WITH_BOOST_CONTEXT "Enable boost::asio stackful coroutines" ON)
if(WITH_BOOST_CONTEXT)
  set(HAVE_BOOST_CONTEXT ON)
endif()

#option for RGW
option(WITH_RADOSGW "Rados Gateway is enabled" ON)
option(WITH_RADOSGW_FCGI_FRONTEND "Rados Gateway's FCGI frontend is enabled" OFF)
option(WITH_RADOSGW_BEAST_FRONTEND "Rados Gateway's Beast frontend is enabled" ON)
option(WITH_RADOSGW_BEAST_OPENSSL "Rados Gateway's Beast frontend uses OpenSSL" ON)

if(WITH_RADOSGW)
  find_package(EXPAT REQUIRED)
  if(WITH_RADOSGW_FCGI_FRONTEND)
    find_package(fcgi REQUIRED)
  endif()
  if(WITH_RADOSGW_BEAST_FRONTEND AND NOT WITH_BOOST_CONTEXT)
    message(WARNING "disabling WITH_RADOSGW_BEAST_FRONTEND, which depends on WITH_BOOST_CONTEXT")

=== debian/changelog ===
ceph (13.2.7-0ubuntu0.19.04.1) disco; urgency=medium

  * New upstream point release (LP: #1855859) including fix for
    ceph-volume performance issues (LP: #1850754).
    - d/p/CVE-2019-10222.patch,bug1832105.patch,
      ceph-volume-wait-for-lvs.patch,issue37490.patch,
      mgr-crash-fix-python3-invalid-syntax-problems.patch,
      more-py3-compat.patch: Drop, included upstream.
    - d/p/misc-32-bit-fixes.patch: Rebased.

 -- James Page <james.page@ubuntu.com>  Wed, 11 Dec 2019 11:05:14 +0000

ceph (13.2.6-0ubuntu0.19.04.4) disco; urgency=medium

  [ Eric Desrochers ]
  * Ensure that daemons are not automatically restarted during package
    upgrades (LP: #1840347):
    - d/rules: Use "--no-restart-after-upgrade" and "--no-stop-on-upgrade"
      instead of "--no-restart-on-upgrade".
    - d/rules: Drop exclusion for ceph-[osd,mon,mds] for restarts.

  [ James Page ]
  * d/p/ceph-volume-wait-for-lvs.patch: Cherry pick inflight fix to
    ensure that required wal and db devices are present before
    activating OSD's (LP: #1828617).

  [ Jesse Williamson ]
  * d/p/civetweb-755-1.8-somaxconn-configurable*.patch: Backport changes
    to civetweb to allow tuning of SOMAXCONN in Ceph RADOS Gateway
    deployments (LP: #1838109).

 -- James Page <james.page@ubuntu.com>  Fri, 30 Aug 2019 10:10:04 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1

# Reduce size of debug symbols to fix FTBFS due to the
# 2GB/3GB address space limits on 32bit
DEB_HOST_ARCH_BITS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)
ifeq (32,$(DEB_HOST_ARCH_BITS))
       export DEB_CFLAGS_MAINT_APPEND = -g1
       export DEB_CXXFLAGS_MAINT_APPEND = -g1
endif

# minimise needless linking and link to libatomic
# The last is needed because long long atomic operations are not directly
# supported by all processor architectures
export DEB_LDFLAGS_MAINT_APPEND= -Wl,--as-needed -latomic

# Enable hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

export JAVA_HOME=/usr/lib/jvm/default-java
## Set JAVAC to prevent FTBFS due to incorrect use of 'gcj' if found (see "m4/ac_prog_javac.m4").
export JAVAC=javac

extraopts += -DWITH_OCF=ON -DWITH_NSS=ON -DWITH_PYTHON3=ON -DWITH_DEBUG=ON
extraopts += -DWITH_PYTHON2=OFF -DMGR_PYTHON_VERSION=3
extraopts += -DWITH_CEPHFS_JAVA=ON
extraopts += -DWITH_LTTNG=OFF -DWITH_EMBEDDED=OFF
extraopts += -DCMAKE_INSTALL_LIBEXECDIR=/usr/lib
extraopts += -DWITH_MGR_DASHBOARD_FRONTEND=OFF
extraopts += -DWITH_SYSTEMD=ON -DCEPH_SYSTEMD_ENV_DIR=/etc/default
extraopts += -DCMAKE_INSTALL_SYSCONFDIR=/etc
extraopts += -DCMAKE_INSTALL_SYSTEMD_SERVICEDIR=/lib/systemd/system

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  extraopts += -DBOOST_J=$(NUMJOBS)
endif

ifeq ($(DEB_HOST_ARCH), s390x)
  # beast depends on libboost_{context,coroutine} which is not supported on s390x
  extraopts += -DWITH_BOOST_CONTEXT=OFF
else
  extraopts += -DWITH_BOOST_CONTEXT=ON
endif

ifeq ($(DEB_HOST_ARCH), i386)
  # Disable SPDK under 32 bit x86 as it fails to build
  extraopts += -DWITH_SPDK=OFF
endif

MAX_PARALLEL ?= $(shell ./debian/calc-max-parallel.sh)

%:
	dh $@ --buildsystem=cmake --with javahelper,python3,systemd $(MAX_PARALLEL)

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- $(extraopts)

override_dh_auto_install:
	dh_auto_install --destdir=$(CURDIR)/debian/tmp --buildsystem=cmake
	# NOTE: manually install python modules to avoid virtualenvs
	#       during the package build process.
	set -e; for comp in ceph-detect-init ceph-disk; do \
		(set -e; cd src/$$comp; python3 setup.py install --root=$(CURDIR)/debian/tmp \
			--install-script=/usr/sbin --install-layout=deb); \
	done
	# NOTE: ensure that any versioned erasure coding test code is dropped
	#       from the package install - package ships unversioned modules.
	rm -f $(CURDIR)/debian/tmp/usr/lib/*/ceph/erasure-code/libec_*.so.*
	find $(CURDIR)/debian/tmp/usr/lib/*/ceph/erasure-code -type l -delete || :
	install -D -m 644 src/etc-rbdmap $(CURDIR)/debian/tmp/etc/ceph/rbdmap
	install -D -m 644 etc/sysctl/90-ceph-osd.conf $(CURDIR)/debian/tmp/etc/sysctl.d/30-ceph-osd.conf

override_dh_installinit:
	dh_installinit --no-start
	dh_installinit -pceph-common --name=rbdmap --no-start
	dh_installinit -pceph-base --name ceph --no-start
	# install the systemd stuff manually since we have funny service names
	# and need to update the paths in all of the files post install
	# systemd:ceph-common
	install -d -m0755 debian/ceph-common/usr/lib/tmpfiles.d
	install -m 0644 -D systemd/ceph.tmpfiles.d debian/ceph-common/usr/lib/tmpfiles.d/ceph.conf
	# NOTE(jamespage): Install previous ceph-mon service from packaging for upgrades
	install -m0644 debian/lib-systemd/system/ceph-mon.service debian/ceph-mon/lib/systemd/system
	# Ensure Debian/Ubuntu specific systemd units are NOT automatically enabled and started
	# Enable systemd targets only
	dh_systemd_enable -Xceph-mon.service -Xceph-osd.service -X ceph-mds.service
	# Start systemd targets only
	dh_systemd_start --no-stop-on-upgrade --no-restart-after-upgrade

override_dh_systemd_enable:
	# systemd enable done as part of dh_installinit

override_dh_systemd_start:
	# systemd start done as part of dh_installinit

override_dh_makeshlibs:
	# exclude jni libraries in libcephfs-jni to avoid pointless ldconfig
	# calls in maintainer scripts; exclude private erasure-code plugins.
	dh_makeshlibs -V -X/usr/lib/jni -X/usr/lib/$(DEB_HOST_MULTIARCH)/ceph/erasure-code

override_dh_auto_test:
	# do not run tests

override_dh_python3:
	for binding in rados cephfs rbd rgw; do \
		dh_python3 -p python3-$$binding --shebang=/usr/bin/python3;      \
        done
	dh_python3 -p python3-ceph-argparse --shebang=/usr/bin/python3
	dh_python3 -p ceph-common --shebang=/usr/bin/python3
	dh_python3 -p ceph-base --shebang=/usr/bin/python3
	dh_python3 -p ceph-osd --shebang=/usr/bin/python3
	dh_python3 -p ceph-mgr --shebang=/usr/bin/python3

## ceph 13.2.8

=== debian/changelog ===
ceph (13.2.8-0ubuntu0.18.10.1~cloud0) bionic; urgency=medium

  * New upstream release for the Ubuntu Cloud Archive (LP: #1864514).
  * d/p/bug1804261.patch: Cherry pick fix to ensure that ceph-volume
    tries and interval environment variables are converted to int
    (LP: #1804261).

 -- James Page <james.page@ubuntu.com>  Tue, 07 Apr 2020 08:55:07 +0100

ceph (13.2.7-0ubuntu0.18.10.1~cloud0) bionic; urgency=medium

  * New upstream release for the Ubuntu Cloud Archive (LP: #1855859)
    including fix for ceph-volume performance issues (LP: #1850754):
    - d/p/CVE-2019-10222.patch,ceph-volume-wait-for-lvs.patch: Drop,
      include in upstream release.
    - d/p/misc-32-bit-fixes.patch: Rebase.

 -- James Page <james.page@ubuntu.com>  Wed, 11 Dec 2019 14:15:36 +0000

ceph (13.2.6-0ubuntu0.18.10.3~cloud0) bionic; urgency=medium

  [ Eric Desrochers ]
  * Ensure that daemons are not automatically restarted during package
    upgrades (LP: #1840347):
    - d/rules: Use "--no-restart-after-upgrade" and "--no-stop-on-upgrade"
      instead of "--no-restart-on-upgrade".
    - d/rules: Drop exclusion for ceph-[osd,mon,mds] for restarts.

  [ James Page ]
  * d/p/ceph-volume-wait-for-lvs.patch: Cherry pick inflight fix to
    ensure that required wal and db devices are present before
    activating OSD's (LP: #1828617).

  [ Jesse Williamson ]
  * d/p/civetweb-755-1.8-somaxconn-configurable*.patch: Backport changes
    to civetweb to allow tuning of SOMAXCONN in Ceph RADOS Gateway
    deployments (LP: #1838109).

 -- Eric Desrochers <eric.desrochers@canonical.com>  Tue, 20 Aug 2019 20:21:13 -0400

ceph (13.2.6-0ubuntu0.18.10.2~cloud0) bionic; urgency=medium

  * SECURITY UPDATE: RADOS gateway remote denial of service
    - d/p/CVE-2019-10222.patch: rgw: asio: check the remote endpoint
      before processing requests.
    - CVE-2019-10222

 -- Steve Beattie <sbeattie@ubuntu.com>  Thu, 29 Aug 2019 10:50:53 +0100

ceph (13.2.6-0ubuntu0.18.10.1~cloud0) bionic; urgency=medium

  * New upstream release for Ubuntu Cloud Archive.

 -- James Page <james.page@ubuntu.com>  Fri, 12 Jul 2019 14:22:15 +0100

ceph (13.2.6-0ubuntu0.18.10.1) cosmic; urgency=medium

  * New upstream release (LP: #1831732).
  * d/p/CVE-2018-16889.patch,CVE-2019-3821.patch: Drop, included in
    release.
  * d/p/misc-32-bit-fixes.patch: Misc updates for 32bit type mismatches.
  * d/{librados2,librbd1}.symbols: Misc updates for new point release.

 -- James Page <james.page@ubuntu.com>  Fri, 21 Jun 2019 06:32:22 +0100

=== debian/rules ===
--- 
+++ 
@@ -25,7 +25,6 @@
 export JAVAC=javac
 
 extraopts += -DWITH_OCF=ON -DWITH_NSS=ON -DWITH_PYTHON3=ON -DWITH_DEBUG=ON
-extraopts += -DWITH_PYTHON2=OFF -DMGR_PYTHON_VERSION=3
 extraopts += -DWITH_CEPHFS_JAVA=ON
 extraopts += -DWITH_LTTNG=OFF -DWITH_EMBEDDED=OFF
 extraopts += -DCMAKE_INSTALL_LIBEXECDIR=/usr/lib
@@ -54,7 +53,7 @@
 MAX_PARALLEL ?= $(shell ./debian/calc-max-parallel.sh)
 
 %:
-	dh $@ --buildsystem=cmake --with javahelper,python3,systemd $(MAX_PARALLEL)
+	dh $@ --buildsystem=cmake --with javahelper,python2,python3,systemd $(MAX_PARALLEL)
 
 override_dh_auto_configure:
 	dh_auto_configure --buildsystem=cmake -- $(extraopts)
@@ -64,7 +63,7 @@
 	# NOTE: manually install python modules to avoid virtualenvs
 	#       during the package build process.
 	set -e; for comp in ceph-detect-init ceph-disk; do \
-		(set -e; cd src/$$comp; python3 setup.py install --root=$(CURDIR)/debian/tmp \
+		(set -e; cd src/$$comp; python setup.py install --root=$(CURDIR)/debian/tmp \
 			--install-script=/usr/sbin --install-layout=deb); \
 	done
 	# NOTE: ensure that any versioned erasure coding test code is dropped
@@ -105,12 +104,19 @@
 override_dh_auto_test:
 	# do not run tests
 
+override_dh_python2:
+	for binding in rados cephfs rbd rgw; do \
+		dh_python2 -p python-$$binding;       \
+	done
+	dh_python2 -p ceph-common
+	dh_python2 -p ceph-base
+	dh_python2 -p ceph-osd
+	dh_python2 -p ceph-mgr
+
 override_dh_python3:
 	for binding in rados cephfs rbd rgw; do \
-		dh_python3 -p python3-$$binding --shebang=/usr/bin/python3;      \
+		dh_python3 -p python3-$$binding;      \
         done
-	dh_python3 -p python3-ceph-argparse --shebang=/usr/bin/python3
-	dh_python3 -p ceph-common --shebang=/usr/bin/python3
-	dh_python3 -p ceph-base --shebang=/usr/bin/python3
-	dh_python3 -p ceph-osd --shebang=/usr/bin/python3
-	dh_python3 -p ceph-mgr --shebang=/usr/bin/python3
+	dh_python3 -p python3-ceph-argparse
+
+.PHONY: override_dh_auto_configure override_dh_installinit override_dh_makeshlibs override_dh_auto_test

## ceph 13.2.9

=== debian/changelog ===
ceph (13.2.9-0ubuntu0.19.04.1~cloud3) bionic-stein; urgency=medium

  * d/p/bug1906496.patch: disable network stats in
    dump_osd_stats (LP: #1906496)

 -- Ponnuvel Palaniyappan <pponnuvel@gmail.com>  Wed, 09 Dec 2020 19:13:35 +0000

ceph (13.2.9-0ubuntu0.19.04.1~cloud2) bionic-stein; urgency=medium

  * d/p/rules: Enable RelWithDebInfo (LP: #1894453).

 -- Corey Bryant <corey.bryant@canonical.com>  Mon, 26 Oct 2020 09:13:45 -0400

ceph (13.2.9-0ubuntu0.19.04.1~cloud0) bionic-stein; urgency=medium

  * New upstream release (LP: #1879482) including change for new
    configuration option in RGW Beast frontend to allow tuning of
    maximum backport of pending connections (LP: #1867386):
    - d/p/bug1804261.patch: Drop, included upstream.

 -- James Page <james.page@ubuntu.com>  Thu, 21 May 2020 08:45:42 +0100

ceph (13.2.8-0ubuntu0.19.04.1~cloud1) bionic; urgency=medium

  * d/p/bug1804261.patch: Cherry pick fix to ensure that ceph-volume
    tries and interval environment variables are converted to int
    (LP: #1804261).
  * New upstream release (LP: #1864514).

 -- James Page <james.page@ubuntu.com>  Mon, 24 Feb 2020 16:58:56 +0000

=== debian/control ===
Source: ceph
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Ceph Maintainers <ceph-maintainers@lists.ceph.com>
Uploaders:
 Laszlo Boszormenyi (GCS) <gcs@debian.org>,
 James Page <jamespage@debian.org>,
Homepage: http://ceph.com/
Vcs-Browser: https://git.launchpad.net/~ubuntu-server-dev/ubuntu/+source/ceph
Vcs-Git: https://git.launchpad.net/~ubuntu-server-dev/ubuntu/+source/ceph
Build-Depends:
 cmake,
 cython,
 cython3,
 debhelper (>= 10~),
 default-jdk,
 dh-exec,
 dh-python,
 dpkg-dev (>= 1.16.1~),
 gperf,
 javahelper,
 junit4,
 libaio-dev,
 libbabeltrace-ctf-dev,
 libbabeltrace-dev,
 libblkid-dev,
 libbz2-dev,
 libcunit1-dev,
 libcurl4-gnutls-dev,
 libedit-dev,
 libexpat1-dev,
 libfuse-dev,
 libgoogle-perftools-dev [i386 amd64 powerpc armhf arm64 ppc64el],
 libibverbs-dev,
 libkeyutils-dev,
 libldap2-dev,
 libleveldb-dev,
 liblz4-dev (>= 0.0~r131),
 libnss3-dev,
 liboath-dev,
 libsnappy-dev,
 libssl-dev,
 libtool,
 libudev-dev,
 libxml2-dev,
 lsb-release,
 pkg-config,
 python3-all-dev,
 python3-bcrypt,
 python3-cherrypy3,
 python3-coverage,
 python3-nose,
 python3-pecan,
 python3-prettytable,
 python3-setuptools,
 python3-sphinx,
 tox,
 uuid-dev,
 uuid-runtime,
 valgrind [amd64 armhf i386 powerpc],
 xfslibs-dev,
 xfsprogs,
 yasm [amd64],
 zlib1g-dev,
Build-Conflicts:
 libcrypto++-dev,
Standards-Version: 3.9.8

Package: ceph
Architecture: linux-any
Depends:
 ceph-mgr (= ${binary:Version}),
 ceph-mon (= ${binary:Version}),
 ceph-osd (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 ceph-mds (= ${binary:Version}),
Description: distributed storage and file system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.

Package: ceph-base
Architecture: linux-any
Depends:
 binutils,
 ceph-common (= ${binary:Version}),
 cryptsetup-bin | cryptsetup,
 gdisk,
 hdparm | sdparm,
 parted,
 uuid-runtime,
 xfsprogs,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Breaks:
 ceph (<< 10.2.2-0ubuntu2~),
 ceph-common (<< 9.2.0-0ubuntu1~),
 ceph-test (<< 9.2.0-0ubuntu1~),
 python-ceph (<< 0.94.1-1~),
Replaces:
 ceph (<< 10.2.2-0ubuntu2~),
 ceph-common (<< 9.2.0-0ubuntu1~),
 ceph-test (<< 9.2.0-0ubuntu1~),
 python-ceph (<< 0.94.1-1~),
Recommends:
 chrony | time-daemon | ntp,
 libcephfs2,
 librados2,
 libradosstriper1,
 librbd1,
Suggests:
 logrotate,
Description: common ceph daemon libraries and management tools
 Ceph is a distributed storage system designed to provide excellent
 performance, reliability, and scalability.
 .
 This package contains the libraries and management tools that are common among
 the Ceph server daemons (ceph-mon, ceph-mgr, ceph-osd, ceph-mds). These tools
 are necessary for creating, running, and administering a Ceph storage cluster.

Package: ceph-common
Architecture: linux-any
Depends:
 librbd1 (= ${binary:Version}),
 python3-cephfs (= ${binary:Version}),
 python3-prettytable,
 python3-rados (= ${binary:Version}),
 python3-rbd (= ${binary:Version}),
 python3-requests,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Conflicts:
 ceph-client-tools,
Breaks:
 ceph (<< 9.2.0-0ubuntu1~),
 ceph-fs-common (<< 12.0.3-0ubuntu1~),
 ceph-test (<< 9.2.0-0ubuntu1~),
 librbd1 (<< 0.94.1-1~),
 python-ceph (<< 0.94.1-1~),
 radosgw (<< 12.0.3-0ubuntu1~),
Replaces:
 ceph (<< 9.2.0-0ubuntu1~),
 ceph-client-tools,
 ceph-fs-common (<< 12.0.3-0ubuntu1~),
 ceph-test (<< 9.2.0-0ubuntu1~),
 librbd1 (<< 0.94.1-1~),
 python-ceph (<< 0.94.1-1~),
 radosgw (<< 12.0.3-0ubuntu1~),
Suggests:
 ceph,
 ceph-mds,
Description: common utilities to mount and interact with a ceph storage cluster
 Ceph is a distributed storage and file system designed to provide
 excellent performance, reliability, and scalability.  This is a collection
 of common tools that allow one to interact with and administer a Ceph cluster.

Package: ceph-fuse
Architecture: amd64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 fuse,
Description: FUSE-based client for the Ceph distributed file system
 Ceph is a distributed network file system designed to provide
 excellent performance, reliability, and scalability.  This is a
 FUSE-based client that allows one to mount a Ceph file system without
 root privileges.
 .
 Because the FUSE-based client has certain inherent performance
 limitations, it is recommended that the native Linux kernel client
 be used if possible.  If it is not practical to load a kernel module
 (insufficient privileges, older kernel, etc.), then the FUSE client will
 do.

Package: ceph-mds
Architecture: linux-any
Depends:
 ceph,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 ceph-common,
 ceph-fuse,
 libcephfs2,
Breaks:
 ceph (<< 0.67.3-1),
Replaces:
 ceph (<< 0.67.3-1),
Description: metadata server for the ceph distributed file system
 Ceph is a distributed storage and network file system designed to
 provide excellent performance, reliability, and scalability.
 .
 This package contains the metadata server daemon, which is used to
 create a distributed file system on top of the ceph storage cluster.

Package: ceph-mgr
Architecture: linux-any
Depends:
 ceph-base (= ${binary:Version}),
 python3-bcrypt,
 python3-cherrypy3,
 python3-jinja2,
 python3-openssl,
 python3-pecan,
 python3-werkzeug,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Replaces:
 ceph (<< 0.93-417),
Breaks:
 ceph (<< 0.93-417),
Description: manager for the ceph distributed file system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the manager daemon, which is used to expose high
 level management and monitoring functionality.

Package: ceph-mon
Architecture: linux-any
Depends:
 ceph-base (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Replaces:
 ceph (<< 10.2.2-0ubuntu2~),
Breaks:
 ceph (<< 10.2.2-0ubuntu2~),
Description: monitor server for the ceph storage system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the cluster monitor daemon for the Ceph storage
 system. One or more instances of ceph-mon form a Paxos part-time parliament
 cluster that provides extremely reliable and durable storage of cluster
 membership, configuration, and state.

Package: ceph-osd
Architecture: linux-any
Depends:
 ceph-base (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ceph-common (= ${binary:Version}),
Replaces:
 ceph (<< 10.2.2-0ubuntu2~),
Breaks:
 ceph (<< 10.2.2-0ubuntu2~),
Description: OSD server for the ceph storage system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the Object Storage Daemon for the Ceph storage system.
 It is responsible for storing objects on a local file system
 and providing access to them over the network.

Package: ceph-resource-agents
Architecture: all
Priority: extra
Recommends:
 pacemaker,
Depends:
 ceph (>= ${binary:Version}),
 resource-agents,
 ${misc:Depends},
Description: OCF-compliant resource agents for Ceph
 Ceph is a distributed storage and network file system designed to provide
 excellent performance, reliability, and scalability.
 .
 This package contains the resource agents (RAs) which integrate
 Ceph with OCF-compliant cluster resource managers,
 such as Pacemaker.

Package: ceph-test
Architecture: linux-any
Depends:
 ceph-common,
 curl,
 jq,
 xml2,
 xmlstarlet,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Ceph test and benchmarking tools
 Ceph is a distributed storage system designed to provide excellent
 performance, reliability, and scalability.
 .
 This package contains tools for testing and benchmarking Ceph.

Package: libcephfs-dev
Architecture: linux-any
Section: libdevel
Depends:
 libcephfs2 (= ${binary:Version}),
 ${misc:Depends},
Conflicts:
 libceph-dev,
 libceph1-dev,
 libcephfs2-dev,
Replaces:
 libceph-dev,
 libceph1-dev,
 libcephfs2-dev,
Description: Ceph distributed file system client library (development files)
 Ceph is a distributed network file system designed to provide
 excellent performance, reliability, and scalability.  This is a
 shared library allowing applications to access a Ceph distributed
 file system via a POSIX-like interface.
 .
 This package contains development files needed for building applications that
 link against libcephfs2.

Package: libcephfs-java
Architecture: all
Section: java
Depends:
 libcephfs-jni (>= ${binary:Version}),
 ${java:Depends},
 ${misc:Depends},
Description: Java library for the Ceph File System
 Ceph is a distributed storage system designed to provide excellent
 performance, reliability, and scalability.
 .
 This package contains the Java library for interacting with the Ceph
 File System.

Package: libcephfs-jni
Architecture: linux-any
Section: libs
Depends:
 libcephfs2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Java Native Interface library for CephFS Java bindings
 Ceph is a distributed storage system designed to provide excellent
 performance, reliability, and scalability.
 .
 This package contains the Java Native Interface library for interacting
 with the Ceph File System.

Package: libcephfs2
Architecture: linux-any
Section: libs
Conflicts:
 libceph,
 libceph1,
 libcephfs,
Replaces:
 libceph,
 libceph1,
 libcephfs,
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: Ceph distributed file system client library
 Ceph is a distributed network file system designed to provide
 excellent performance, reliability, and scalability.  This is a
 shared library allowing applications to access a Ceph distributed
 file system via a POSIX-like interface.

Package: librados-dev
Architecture: linux-any
Section: libdevel
Depends:
 librados2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 librados1-dev,
 librados2-dev,
Replaces:
 librados1-dev,
 librados2-dev,
Description: RADOS distributed object store client library (development files)
 RADOS is a reliable, autonomic distributed object storage cluster
 developed as part of the Ceph distributed storage system.  This is a
 shared library allowing applications to access the distributed object
 store using a simple file-like interface.
 .
 This package contains development files needed for building applications that
 link against librados2.

Package: librados2
Architecture: linux-any
Section: libs
Conflicts:
 librados,
 librados1,
Replaces:
 librados,
 librados1,
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: RADOS distributed object store client library
 RADOS is a reliable, autonomic distributed object storage cluster
 developed as part of the Ceph distributed storage system.  This is a
 shared library allowing applications to access the distributed object
 store using a simple file-like interface.

Package: libradosstriper-dev
Architecture: linux-any
Section: libdevel
Depends:
 libradosstriper1 (= ${binary:Version}),
 ${misc:Depends},
Description: RADOS striping interface (development files)
 libradosstriper is a striping interface built on top of the rados
 library, allowing to stripe bigger objects onto several standard
 rados objects using an interface very similar to the rados one.
 .
 This package contains development files needed for building applications that
 link against libradosstriper.

Package: libradosstriper1
Architecture: linux-any
Section: libs
Depends:
 librados2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: RADOS striping interface

=== debian/rules ===
--- 
+++ 
@@ -25,6 +25,7 @@
 export JAVAC=javac
 
 extraopts += -DWITH_OCF=ON -DWITH_NSS=ON -DWITH_PYTHON3=ON -DWITH_DEBUG=ON
+extraopts += -DWITH_PYTHON2=OFF -DMGR_PYTHON_VERSION=3
 extraopts += -DWITH_CEPHFS_JAVA=ON
 extraopts += -DWITH_LTTNG=OFF -DWITH_EMBEDDED=OFF
 extraopts += -DCMAKE_INSTALL_LIBEXECDIR=/usr/lib
@@ -32,6 +33,9 @@
 extraopts += -DWITH_SYSTEMD=ON -DCEPH_SYSTEMD_ENV_DIR=/etc/default
 extraopts += -DCMAKE_INSTALL_SYSCONFDIR=/etc
 extraopts += -DCMAKE_INSTALL_SYSTEMD_SERVICEDIR=/lib/systemd/system
+ifneq ($(DEB_HOST_ARCH), armhf)
+extraopts += -DCMAKE_BUILD_TYPE=RelWithDebInfo
+endif
 
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
   NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
@@ -53,7 +57,7 @@
 MAX_PARALLEL ?= $(shell ./debian/calc-max-parallel.sh)
 
 %:
-	dh $@ --buildsystem=cmake --with javahelper,python2,python3,systemd $(MAX_PARALLEL)
+	dh $@ --buildsystem=cmake --with javahelper,python3,systemd $(MAX_PARALLEL)
 
 override_dh_auto_configure:
 	dh_auto_configure --buildsystem=cmake -- $(extraopts)
@@ -63,7 +67,7 @@
 	# NOTE: manually install python modules to avoid virtualenvs
 	#       during the package build process.
 	set -e; for comp in ceph-detect-init ceph-disk; do \
-		(set -e; cd src/$$comp; python setup.py install --root=$(CURDIR)/debian/tmp \
+		(set -e; cd src/$$comp; python3 setup.py install --root=$(CURDIR)/debian/tmp \
 			--install-script=/usr/sbin --install-layout=deb); \
 	done
 	# NOTE: ensure that any versioned erasure coding test code is dropped
@@ -104,19 +108,12 @@
 override_dh_auto_test:
 	# do not run tests
 
-override_dh_python2:
-	for binding in rados cephfs rbd rgw; do \
-		dh_python2 -p python-$$binding;       \
-	done
-	dh_python2 -p ceph-common
-	dh_python2 -p ceph-base
-	dh_python2 -p ceph-osd
-	dh_python2 -p ceph-mgr
-
 override_dh_python3:
 	for binding in rados cephfs rbd rgw; do \
-		dh_python3 -p python3-$$binding;      \
+		dh_python3 -p python3-$$binding --shebang=/usr/bin/python3;      \
         done
-	dh_python3 -p python3-ceph-argparse
-
-.PHONY: override_dh_auto_configure override_dh_installinit override_dh_makeshlibs override_dh_auto_test
+	dh_python3 -p python3-ceph-argparse --shebang=/usr/bin/python3
+	dh_python3 -p ceph-common --shebang=/usr/bin/python3
+	dh_python3 -p ceph-base --shebang=/usr/bin/python3
+	dh_python3 -p ceph-osd --shebang=/usr/bin/python3
+	dh_python3 -p ceph-mgr --shebang=/usr/bin/python3
